&product; &date; Developer Moritz Bunkus moritz@bunkus.org
&product;
1
&version;
&date;
MkvToolNix
User Commands

# &product;

extract tracks from &matroska; files into other files

## Synopsis

       mkvextract
       mode
       source-filename
       options
       extraction-spec

## Description

This program extracts specific parts from a &matroska; file to other useful formats. The first argument, `mode`, tells &mkvextract; what to extract. Currently supported is the extraction of tracks, tags, attachments, chapters, CUE sheets and timecodes. The second argument is the name of the source file. It must be a &matroska; file. All following arguments are options and extraction specifications; both of which depend on the selected mode.

### Common options

The following options are available in all modes and only described once in this section.

`-f`, `--parse-fully`

  Sets the parse mode to 'full'. The default mode does not parse the whole file but uses the meta seek elements for locating the required elements of a source file. In 99% of all cases this is enough. But for files that do not contain meta seek elements or which are damaged the user might have to use this mode. A full scan of a file can take a couple of minutes while a fast scan only takes seconds.

`--command-line-charset` `character-set`

  Sets the character set to convert strings given on the command line from. It defaults to the character set given by system's current locale.

`--output-charset` `character-set`

  Sets the character set to which strings are converted that are to be output. It defaults to the character set given by system's current locale.

`-r`, `--redirect-output` `file-name`

  Writes all messages to the file `file-name` instead of to the console. While this can be done easily with output redirection there are cases in which this option is needed: when the terminal reinterprets the output before writing it to a file. The character set set with `--output-charset` is honored.

`--ui-language` `code`

  Forces the translations for the language `code` to be used (e.g. '`de_DE`' for the German translations). It is preferable to use the environment variables `LANG`, `LC_MESSAGES` and `LC_ALL` though. Entering '`list`' as the `code` will cause &mkvextract; to output a list of available translations.

`-v`, `--verbose`

  Be verbose and show all the important &matroska; elements as they're read.

`-h`, `--help`

  Show usage information and exit.

`-V`, `--version`

  Show version information and exit.

`--check-for-updates`

  Checks online for new releases by downloading the URL `http://mkvtoolnix-releases.bunkus.org/latest-release.xml`. Four lines will be output in `key=value` style: the URL from where the information was retrieved (key `version_check_url`), the currently running version (key `running_version`), the latest release's version (key `available_version`) and the download URL (key `download_url`).

  Afterwards the program exists with an exit code of 0 if no newer release is available, with 1 if a newer release is available and with 2 if an error occured (e.g. if the update information could not be retrieved).

  This option is only available if the program was built with support for libcurl.

`@`options-file

  Reads additional command line arguments from the file `options-file`. Lines whose first non-whitespace character is a hash mark ('`#`') are treated as comments and ignored. White spaces at the start and end of a line will be stripped. Each line must contain exactly one option.

  Several chars can be escaped, e.g. if you need to start a non-comment line with '#'. The rules are described in the section about escaping text.

  The command line '`mkvextract tracks source.mkv --raw 1:destination.raw`' could be converted into the following option file:

      # Extract a track from source.mkv
      tracks
      source.mkv
      # Output the track as raw data.
      --raw
      1:destination.raw

### Track extraction mode

Syntax: `mkvextract` `tracks` `source-filename` `options` `TID1:dest-filename1` `TID2:dest-filename2` ...

The following command line options are available for each track in the '`tracks`' extraction mode. They have to appear in front of the track specification (see below) they should be applied to.

`-c` `character-set`

  Sets the character set to convert the next text subtitle track to. Only valid if the next track ID targets a text subtitle track. It defaults to UTF-8.

`--blockadd` `level`

  Keep only the BlockAdditions up to this level. The default is to keep all levels. This option only affects certain kinds of codecs like WAVPACK4.

`--cuesheet`

  Causes &mkvextract; to extract a CUE sheet from the chapter information and tag data for the following track into a file whose name is the track's output name with '`.cue`' appended to it.

`--raw`

  Extracts the raw data into a file without any container data around it. Unlike the `--fullraw` flag this flag does not cause the contents of the `CodecPrivate` element to be written to the file. This mode works with all `CodecIDs`, even the ones that &mkvextract; doesn't support otherwise, but the resulting files might not be usable.

`--fullraw`

  Extracts the raw data into a file without any container data around it. The contents of the `CodecPrivate` element will be written to the file first if the track contains such a header element. This mode works with all `CodecIDs`, even the ones that &mkvextract; doesn't support otherwise, but the resulting files might not be usable.

`TID:outname`

  Causes extraction of the track with the ID `TID` into the file `outname` if such a track exists in the source file. This option can be given multiple times. The track IDs are the same as the ones output by &mkvmerge;'s `--identify` option.

  Each output name should be used only once. The exception are RealAudio and RealVideo tracks. If you use the same name for different tracks then those tracks will be saved in the same file. Example:

      $ mkvextract tracks input.mkv 1:output-two-tracks.rm 2:output-two-tracks.rm

### Tags extraction mode

Syntax: `mkvextract` `tags` `source-filename` `options`

The extracted tags are written to the console unless the output is redirected (see the section about output redirection for details).

### Attachments extraction mode

Syntax: `mkvextract` `attachments` `source-filename` `options` `AID1:outname1` `AID2:outname2` ...

AID:outname

  Causes extraction of the attachment with the ID `AID` into the file `outname` if such an attachment exists in the source file. If the `outname` is left empty then the name of the attachment inside the source &matroska; file is used instead. This option can be given multiple times. The attachment IDs are the same as the ones output by &mkvmerge;'s `--identify` option.

### Chapters extraction mode

Syntax: `mkvextract` `chapters` `source-filename` `options`

`-s`, `--simple`

  Exports the chapter information in the simple format used in the OGM tools (CHAPTER01=..., CHAPTER01NAME=...). In this mode some information has to be discarded. Default is to output the chapters in &xml; format.

The extracted chapters are written to the console unless the output is redirected (see the section about output redirection for details).

### Cue sheet extraction mode

Syntax: `mkvextract` `cuesheet` `source-filename` `options`

The extracted cue sheet is written to the console unless the output is redirected (see the section about output redirection for details).

### Timecode extraction mode

Syntax: `mkvextract` `timecodes_v2` `source-filename` `options` `TID1:dest-filename1` `TID2:dest-filename2` ...

The extracted timecodes are written to the console unless the output is redirected (see the section about output redirection for details).

`TID:outname`

  Causes extraction of the timecodes for the track with the ID `TID` into the file `outname` if such a track exists in the source file. This option can be given multiple times. The track IDs are the same as the ones output by &mkvmerge;'s `--identify` option.

  Example:

      $ mkvextract timecodes_v2 input.mkv 1:tc-track1.txt 2:tc-track2.txt

## Output redirection

Several extraction modes cause &mkvextract; to write the extracted data to the console. There are generally two ways of writing this data into a file: one provided by the shell and one provided by &mkvextract; itself.

The shell's builtin redirection mechanism is used by appending '`> output-filename.ext`' to the command line. Example:

    $ mkvextract tags source.mkv > tags.xml

&mkvextract;'s own redirection is invoked with the `--redirect-output` option. Example:

    $ mkvextract tags source.mkv --redirect-output tags.xml

On Windows you should probably use the `--redirect-output` option because `cmd.exe` sometimes interpretes special characters before they're written into the output file resulting in broken output.

## Output file formats

The decision about the output format is based on the track type, not on the extension used for the output file name. The following track types are supported at the moment:

V_MPEG4/ISO/AVC

  H.264 / AVC video tracks are written to H.264 elementary streams which can be processed further with e.g. MP4Box from the GPAC package.

V_MS/VFW/FOURCC

  Fixed FPS video tracks with this `CodecID` are written to AVI files.

V_REAL/*

  RealVideo tracks are written to RealMedia files.

A_MPEG/L3, A_AC3

  These will be extracted to raw MP3 and AC3 files.

A_PCM/INT/LIT

  Raw PCM data will be written to a WAV file.

A_AAC/MPEG2/*, A_AAC/MPEG4/*, A_AAC

  All AAC files will be written into an AAC file with ADTS headers before each packet. The ADTS headers will not contain the deprecated emphasis field.

A_VORBIS

  Vorbis audio will be written into an &oggvorbis; file.

A_REAL/*

  RealAudio tracks are written to RealMedia files.

A_TTA1

  TrueAudio tracks are written to TTA files. Please note that due to &matroska;'s limited timecode precision the extracted file's header will be different regarding two fields: `data_length` (the total number of samples in the file) and the CRC.

S_TEXT/UTF8

  Simple text subtitles will be written as SRT files.

S_TEXT/SSA, S_TEXT/ASS

  SSA and ASS text subtitles will be written as SSA/ASS files respectively.

S_KATE

  Kate streams will be written within an Ogg container.

Tags

  Tags are converted to a &xml; format. This format is the same that &mkvmerge; supports for reading tags.

Attachments

  Attachments are written to they output file as they are. No conversion whatsoever is done.

Chapters

  Chapters are converted to a &xml; format. This format is the same that &mkvmerge; supports for reading chapters. Alternatively a stripped-down version can be output in the simple OGM style format.

Timecodes

  Timecodes are first sorted and then output as a timecode v2 format compliant file ready to be fed to &mkvmerge;. The extraction to other formats (v1, v3 and v4) is not supported.

## Exit codes

&mkvextract; exits with one of three exit codes:

- `0` -- This exit codes means that extraction has completed successfully.

- `1` -- In this case &mkvextract; has output at least one warning, but extraction did continue. A warning is prefixed with the text '`Warning:`'. Depending on the issues involved the resulting files might be ok or not. The user is urged to check both the warning and the resulting files.

- `2` -- This exit code is used after an error occurred. &mkvextract; aborts right after outputting the error message. Error messages range from wrong command line arguments over read/write errors to broken files.

## Escaping special chars in text

There are a few places in which special characters in text must or should be escaped. The rules for escaping are simple: each character that needs escaping is replaced with a backslash followed by another character.

The rules are: ' ' becomes '\s', '"' becomes '\2', ':' becomes '\c', '#' becomes '\h' and '\' itself becomes '\\'.

## See also

&mkvmerge;, &mkvinfo;, &mkvpropedit;, &mmg;

## WWW

The latest version can always be found at the MKVToolNix homepage.